#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
    char* genre;
    int play;
} GenrePlay;

typedef struct {
    int index;
    int play;
} IndexPlay;

int cmp_genre_play(const void* a, const void* b) {
    return ((GenrePlay*)b)->play - ((GenrePlay*)a)->play;
}

int cmp_index_play(const void* a, const void* b) {
    return ((IndexPlay*)b)->play - ((IndexPlay*)a)->play;
}

int* solution(char** genres, int genresSize, int* plays, int playsSize, int* returnSize) {
    GenrePlay summary[genresSize];
    memset(summary, 0, sizeof(summary));
    IndexPlay plays_summary[genresSize][2];
    memset(plays_summary, 0, sizeof(plays_summary));
    for (int i = 0; i < genresSize; i++) {
        int found = 0;
        for (int j = 0; j < genresSize; j++) {
            if (summary[j].genre == NULL) {
                summary[j].genre = genres[i];
                summary[j].play = plays[i];
                plays_summary[j][0].index = i;
                plays_summary[j][0].play = plays[i];
                found = 1;
                break;
            } else if (strcmp(summary[j].genre, genres[i]) == 0) {
                summary[j].play += plays[i];
                if (plays[i] > plays_summary[j][0].play) {
                    plays_summary[j][1] = plays_summary[j][0];
                    plays_summary[j][0].index = i;
                    plays_summary[j][0].play = plays[i];
                } else if (plays[i] > plays_summary[j][1].play) {
                    plays_summary[j][1].index = i;
                    plays_summary[j][1].play = plays[i];
                }
                found = 1;
                break;
            }
        }
        if (!found) {
            summary[genresSize].genre = genres[i];
            summary[genresSize].play = plays[i];
            plays_summary[genresSize][0].index = i;
            plays_summary[genresSize][0].play = plays[i];
        }
    }

    qsort(summary, genresSize, sizeof(GenrePlay), cmp_genre_play);
    *returnSize = 0;
    int* result = (int*)malloc(genresSize * sizeof(int));
    for (int i = 0; i < genresSize; i++) {
        if (summary[i].genre == NULL) {
            break;
        }
        for (int j = 0; j < genresSize; j++) {
            if (plays_summary[j][0].index == 0 && plays_summary[j][0].play == 0) {
                break;
            }
            if (strcmp(summary[i].genre, genres[j]) == 0) {
                qsort(plays_summary[j], 2, sizeof(IndexPlay), cmp_index_play);
                result[(*returnSize)++] = plays_summary[j][0].index;
                if (plays_summary[j][1].index != 0 || plays_summary[j][1].play != 0) {
                    result[(*returnSize)++] = plays_summary[j][1].index;
                }
                break;
            }
        }
    }

    return result;
}
