#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX_ID 1000
#define MAX_REPORT 10000

typedef struct {
    char *reporter;
    char *reported;
} Report;

typedef struct {
    char *id;
    int count;
} Count;

int cmp_count(const void *a, const void *b) {
    return strcmp(((Count *)a)->id, ((Count *)b)->id);
}

int cmp_report(const void *a, const void *b) {
    return strcmp(((Report *)a)->reporter, ((Report *)b)->reporter);
}

int *solution(char **id_list, int id_list_len, char **report, int report_len, int k) {
    Report reports[MAX_REPORT];
    Count counts[MAX_ID];
    int result[MAX_ID] = {0};

    for (int i = 0; i < id_list_len; i++) {
        counts[i].id = id_list[i];
        counts[i].count = 0;
    }

    qsort(counts, id_list_len, sizeof(Count), cmp_count);

    for (int i = 0; i < report_len; i++) {
        char *reporter = strtok(report[i], " ");
        char *reported = strtok(NULL, " ");
        reports[i].reporter = reporter;
        reports[i].reported = reported;

        Count key = {.id = reported};
        Count *count = bsearch(&key, counts, id_list_len, sizeof(Count), cmp_count);
        count->count++;
    }

    qsort(reports, report_len, sizeof(Report), cmp_report);

    for (int i = 0; i < id_list_len; i++) {
        char *id = id_list[i];
        Report key = {.reporter = id};
        Report *first_report = bsearch(&key, reports, report_len, sizeof(Report), cmp_report);

        if (first_report != NULL) {
            int j = first_report - reports;
            while (j < report_len && strcmp(reports[j].reporter, id) == 0) {
                Count key = {.id = reports[j].reported};
                Count *count = bsearch(&key, counts, id_list_len, sizeof(Count), cmp_count);
                if (count->count >= k) {
                    result[i]++;
                }
                j++;
            }
        }
    }

    int *result_ptr = malloc(id_list_len * sizeof(int));
    memcpy(result_ptr, result, id_list_len * sizeof(int));
    return result_ptr;
}
