#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

typedef struct {
    int x;
    int y;
} Point;

bool is_safe(int x, int y, int n, int m, int maps[n][m], int visited[n][m]) {
    return x >= 0 && x < n && y >= 0 && y < m && !visited[x][y] && maps[x][y];
}

int solution(int n, int m, int maps[n][m]) {
    Point queue[1000000];
    int head = 0;
    int tail = 0;
    int visited[n][m];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            visited[i][j] = 0;
        }
    }

    queue[tail++] = (Point){0, 0};
    visited[0][0] = 1;
    int distance[n * m];
    distance[0] = 1;
    int dx[] = {-1, 1, 0, 0};
    int dy[] = {0, 0, -1, 1};

    while (head < tail) {
        Point point = queue[head++];
        int x = point.x;
        int y = point.y;

        for (int i = 0; i < sizeof(dx) / sizeof(dx[0]); i++) {
            int nx = x + dx[i];
            int ny = y + dy[i];

            if (is_safe(nx, ny, n, m, maps, visited)) {
                if (nx == n - 1 && ny == m - 1) {
                    return distance[x * m + y] + 1;
                }
                queue[tail++] = (Point){nx, ny};
                distance[nx * m + ny] = distance[x * m + y] + 1;
                visited[nx][ny] = 1;
            }
        }
    }

    return -1;
}
