#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#define MAX_SIZE 3200000

typedef struct {
    int *array;
    int size;
} Array;

Array *newArray() {
    Array *array = malloc(sizeof(Array));
    array->array = malloc(MAX_SIZE * sizeof(int));
    array->size = 0;
    return array;
}

void add(Array *array, int value) {
    array->array[array->size++] = value;
}

bool contains(Array *array, int value) {
    for (int i = 0; i < array->size; i++) {
        if (array->array[i] == value) {
            return true;
        }
    }
    return false;
}

int solution(int N, int number) {
    Array **memo = malloc(8 * sizeof(Array *));
    for (int i = 0; i < 8; i++) {
        memo[i] = newArray();
    }

    for (int i = 1; i <= 8; i++) {
        int num = 0;
        for (int j = 0; j < i; j++) {
            num = num * 10 + N;
        }
        add(memo[i - 1], num);

        for (int j = 0; j < i - 1; j++) {
            for (int k = 0; k < memo[j]->size; k++) {
                for (int l = 0; l < memo[i - j - 2]->size; l++) {
                    int x = memo[j]->array[k];
                    int y = memo[i - j - 2]->array[l];
                    add(memo[i - 1], x + y);
                    add(memo[i - 1], x - y);
                    add(memo[i - 1], x * y);
                    if (y != 0) {
                        add(memo[i - 1], x / y);
                    }
                }
            }
        }

        if (contains(memo[i - 1], number)) {
            return i;
        }
    }

    return -1;
}
