#include <stdio.h>
#include <stdlib.h>

int compare(const void *a, const void *b) {
    int arg1 = *(const int *)a;
    int arg2 = *(const int *)b;
    return (arg1 > arg2) - (arg1 < arg2);
}

int *solution(int N, int stages[], int size) {
    int *result = malloc(N * sizeof(int));
    int *counts = malloc((N + 1) * sizeof(int));
    for (int i = 0; i < N + 1; i++) {
        counts[i] = 0;
    }
    for (int i = 0; i < size; i++) {
        counts[stages[i]]++;
    }

    int denominator = size;
    for (int stage = 1; stage <= N; stage++) {
        if (denominator) {
            int count = counts[stage];
            result[stage - 1] = count / denominator;
            denominator -= count;
        } else {
            result[stage - 1] = 0;
        }
    }

    qsort(result, N, sizeof(int), compare);

    return result;
}
