#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#define MAX_SIZE 3200000

typedef struct {
    int *array;
    int size;
} Array;

Array *newArray() {
    Array *array = malloc(sizeof(Array));
    array->array = malloc(MAX_SIZE * sizeof(int));
    array->size = 0;
    return array;
}

void add(Array *array, int value) {
    array->array[array->size++] = value;
}

bool contains(Array *array, int value) {
    for (int i = 0; i < array->size; i++) {
        if (array->array[i] == value) {
            return true;
        }
    }
    return false;
}

int solution(int **board, int size) {
    Array *danger = newArray();
    for (int i = 0; i < size; i++) {
        for (int j = 0; j < size; j++) {
            if (board[i][j]) {
                for (int di = -1; di <= 1; di++) {
                    for (int dj = -1; dj <= 1; dj++) {
                        if (0 <= i + di && i + di < size && 0 <= j + dj && j + dj < size) {
                            int value = (i + di) * size + j + dj;
                            if (!contains(danger, value)) {
                                add(danger, value);
                            }
                        }
                    }
                }
            }
        }
    }

    return size * size - danger->size;
}
