#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

int *solution(int numbers[], int size) {
    int *result = malloc(size * sizeof(int));

    for (int i = 0; i < size; i++) {
        int number = numbers[i];
        char bin_number[32];
        sprintf(bin_number, "%d", number);
        int bin_length = strlen(bin_number);

        int node_count = pow(2, (int)log2(bin_length) + 1) - 1;
        char bin_number_padded[32];
        sprintf(bin_number_padded, "%0*d%s", node_count - bin_length, 0, bin_number);

        if (bin_number_padded[node_count / 2] == '0') {
            result[i] = 0;
            continue;
        }

        int is_possible = 1;
        int stack_size = 0;
        int stack[32][2];
        stack[stack_size][0] = 0;
        stack[stack_size++][1] = node_count - 1;

        while (stack_size > 0) {
            int left = stack[--stack_size][0];
            int right = stack[stack_size][1];

            if (left == right) {
                continue;
            }

            int center = (left + right) / 2;

            if (bin_number_padded[center] == '0' && strchr(bin_number_padded + left, '1') != NULL) {
                is_possible = 0;
                break;
            }

            stack[stack_size][0] = left;
            stack[stack_size++][1] = center - 1;
            stack[stack_size][0] = center + 1;
            stack[stack_size++][1] = right;
        }

        result[i] = is_possible;
    }

    return result;
}
