#include <stdio.h>
#include <stdbool.h>
#include <string.h>

bool is_safe(int x, int y, int width, int height) {
    return -width <= x && x <= width && -height <= y && y <= height;
}

int *solution(char **keyinput, int size, int board[]) {
    int width = board[0] / 2;
    int height = board[1] / 2;
    int *pos = malloc(2 * sizeof(int));
    pos[0] = 0;
    pos[1] = 0;

    for (int i = 0; i < size; i++) {
        char *key = keyinput[i];
        int move[2];
        if (strcmp(key, "up") == 0) {
            move[0] = 0;
            move[1] = 1;
        } else if (strcmp(key, "down") == 0) {
            move[0] = 0;
            move[1] = -1;
        } else if (strcmp(key, "right") == 0) {
            move[0] = 1;
            move[1] = 0;
        } else {
            move[0] = -1;
            move[1] = 0;
        }

        if (is_safe(pos[0] + move[0], pos[1] + move[1], width, height)) {
            pos[0] += move[0];
            pos[1] += move[1];
        }
    }

    return pos;
}
