#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *solution(int numbers[], int size, char *hand) {
    char *answer = malloc((size + 1) * sizeof(char));
    answer[size] = '\0';

    int left[] = {3, 2, 1};
    int right[] = {3, 2, 1};
    int center[] = {3, 2, 1, 0};

    int left_pos[] = {0, 0};
    int right_pos[] = {2, 0};

    for (int i = 0; i < size; i++) {
        int number = numbers[i];
        if (number == 1 || number == 4 || number == 7) {
            answer[i] = 'L';
            left_pos[0] = 0;
            left_pos[1] = left[number / 3];
        } else if (number == 3 || number == 6 || number == 9) {
            answer[i] = 'R';
            right_pos[0] = 2;
            right_pos[1] = right[number / 3 - 1];
        } else {
            int left_dist = abs(1 - left_pos[0]) + abs(left_pos[1] - center[number / 3]);
            int right_dist = abs(right_pos[0] - 1) + abs(right_pos[1] - center[number / 3]);

            if (left_dist < right_dist) {
                answer[i] = 'L';
                left_pos[0] = 1;
                left_pos[1] = center[number / 3];
            } else if (left_dist > right_dist) {
                answer[i] = 'R';
                right_pos[0] = 1;
                right_pos[1] = center[number / 3];
            } else {
                if (strcmp(hand, "left") == 0) {
                    answer[i] = 'L';
                    left_pos[0] = 1;
                    left_pos[1] = center[number / 3];
                } else {
                    answer[i] = 'R';
                    right_pos[0] = 1;
                    right_pos[1] = center[number / 3];
                }
            }
        }
    }

    return answer;
}
