import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;

public class Solution {
    public static int[] solution(String[] genres, int[] plays) {
        HashMap<String, ArrayList<Integer>> summary = new HashMap<>();
        HashMap<String, Integer> playsSummary = new HashMap<>();
        for (int index=0; index<genres.length; index++){
            String genre=genres[index];
            int play=plays[index];

            ArrayList<Integer> list=summary.getOrDefault(genre,new ArrayList<>());
            list.add(index);
            summary.put(genre,list);

            int totalPlays=playsSummary.getOrDefault(genre,0)+play;
            playsSummary.put(genre,totalPlays);
        }

        ArrayList<String> byPlays=new ArrayList<>(playsSummary.keySet());
        Collections.sort(byPlays,(a,b)->playsSummary.get(b)-playsSummary.get(a));

        ArrayList<Integer> result=new ArrayList<>();
        for(String genre:byPlays){
            ArrayList<Integer> songs=summary.get(genre);
            Collections.sort(songs,(a,b)->plays[b]-plays[a]);
            result.add(songs.get(0));
            if(songs.size()>1){
                result.add(songs.get(1));
            }
        }

        return result.stream().mapToInt(i->i).toArray();
    }
}
