import java.util.*;

public class Solution {
    static class Point {
        public final int x;
        public final int y;

        public Point(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }

    public static boolean isSafe(int x, int y, boolean[][] visited, boolean[][] maps) {
        return x >= 0 && x < maps.length && y >= 0 && y < maps[0].length && !visited[x][y] && maps[x][y];
    }

    public static int solution(int[][] maps) {
        final var n = maps.length;
        final var m = maps[0].length;

        boolean[][] visited = new boolean[n][m];
        Queue<Point> queue = new LinkedList<>();
        queue.add(new Point(0, 0));
        visited[0][0] = true;

        Map<Point, Integer> distanceMap = new HashMap<>();
        distanceMap.put(new Point(0, 0), 1);

        final var dx = new int[]{-1, 1, 0, 0};
        final var dy = new int[]{0, 0, -1, 1};

        while (!queue.isEmpty()) {
            Point point = queue.poll();
            final var x = point.x;
            final var y = point.y;

            for (int i = 0; i < dx.length; i++) {
                final var nx = x + dx[i];
                final var ny = y + dy[i];

                if (isSafe(nx, ny, visited, maps)) {
                    if (nx == n - 1 && ny == m - 1) {
                        return distanceMap.get(point) + 1;
                    }
                    queue.add(new Point(nx, ny));
                    distanceMap.put(new Point(nx, ny), distanceMap.get(point) + 1);
                    visited[nx][ny] = true;
                }
            }
        }

        return -1;
    }
}
