import java.util.Arrays;
import java.util.HashMap;

public class Solution {
    public static int[] solution(int N, int[] stages) {
        HashMap<Integer, Integer> result = new HashMap<>();
        HashMap<Integer, Integer> counts = new HashMap<>();
        for (int stage : stages) {
            counts.put(stage, counts.getOrDefault(stage, 0) + 1);
        }

        int denominator = stages.length;
        for (int stage = 1; stage <= N; stage++) {
            if (denominator != 0) {
                int count = counts.getOrDefault(stage, 0);
                result.put(stage, count / denominator);
                denominator -= count;
            } else {
                result.put(stage, 0);
            }
        }

        return result.entrySet().stream()
                .sorted((e1, e2) -> e2.getValue().compareTo(e1.getValue()))
                .mapToInt(e -> e.getKey())
                .toArray();
    }
}
