import java.util.Stack;

public class Solution {
    public static int[] solution(int[] numbers) {
        int[] result = new int[numbers.length];

        for (int i = 0; i < numbers.length; i++) {
            String bin_number = Integer.toBinaryString(numbers[i]);
            int bin_length = bin_number.length();

            int node_count = (int)Math.pow(2, (int)Math.log(bin_length) / Math.log(2) + 1) - 1;
            String bin_number_padded =
                    "0".repeat(node_count - bin_length) + bin_number;

            if (bin_number_padded.charAt(node_count / 2) == '0') {
                result[i] = 0;
                continue;
            }

            boolean is_possible = true;
            Stack<int[]> stack = new Stack<>();
            stack.push(new int[]{0, node_count - 1});

            while (!stack.isEmpty()) {
                int[] range = stack.pop();
                int left = range[0];
                int right = range[1];

                if (left == right) {
                    continue;
                }

                int center = (left + right) / 2;

                if (bin_number_padded.charAt(center) == '0' &&
                        bin_number_padded.substring(left, right + 1).contains("1")) {
                    is_possible = false;
                    break;
                }

                stack.push(new int[]{left, center - 1});
                stack.push(new int[]{center + 1, right});
            }

            result[i] = is_possible ? 1 : 0;
        }

        return result;
    }
}
